/**
 * Characteristic.java
 *
 * Created on Jul 10, 2006
 */
package maths;

/**
 * Cette classe implemente la fonction characteristique d'un ensemble.
 *
 * @author Nicolae
 */
public class Characteristic implements Fonction {

	private DefaultSet A;

	/**
	 * Cache le constructor standard.
	 */
	private Characteristic() {}

	/**
	 * Constructor qui initialise l'ensemble.
	 *
	 * @param A ensemble.
	 */
	public Characteristic(DefaultSet A) {
		this.A = A;
	}

	/* (non-Javadoc)
	 * @see maths.Fonction#setPar(double, double, int)
	 */
	public void setPar(double re, double im, int n) { }

	/* (non-Javadoc)
	 * @see maths.Fonction#getVal(double, double)
	 */
	public int getVal(double x, double y) {
		return A.contains(x, y) ? 1 : 0;
	}

}
