/**
 * Complement.java
 *
 * Created on Jul 10, 2006
 */
package maths;

/**
 * Cette classe implemente le complement d'un ensemble.
 *
 * @author Nicolae
 */
public class Complement extends DefaultSet {

	private Set A;
	
	/**
	 * Cache le constructor standard.
	 */
	private Complement() {}
		
	/**
	 * Constructor qui initialise l'ensemble.
	 *
	 * @param A ensemble.
	 */
	public Complement(Set A) {
		this.A = A;
	}
	
	/* (non-Javadoc)
	 * @see maths.DefaultSet#contains(double, double)
	 */
	public boolean contains(double re, double im) {
		return ! A.contains(re, im);
	}
}
