/**
 * Sum.java
 *
 * Created on Jul 10, 2006
 */
package maths;

/**
 * Cette classe implemente la difference de deux fonctions.
 *
 * @author Nicolae
 */
public class Diff extends DefaultMap {

	private Map f;
	private Map g;

	private double[] v1 = new double[2]; 
	private double[] v2 = new double[2]; 
	
	/**
	 * Cache le constructor standard.
	 */
	private Diff() {}
	
	/**
	 * Constructor qui initialise les deux applications.
	 *
	 * @param f application.
	 * @param f application.
	 */
	public Diff(Map f, Map g) {
		this.f = f;
		this.g = g;
	}

	protected void apply() {
		f.value(x, y, v1);
		g.value(x, y, v2);

		fx = v1[0] - v2[0];
		fy = v1[1] - v2[1];
	}

	public Map[] inverse() {
		return null;
	}

	public void compDiff() {
		Map df = f.differential();
		Map dg = g.differential();
		
		if(df == null || dg == null)
			der = null;
		else
			der = new Diff(df, dg);
	}
}
