/**
 * Sum.java
 *
 * Created on Jul 10, 2006
 */
package maths;

/**
 * Cette classe implemente la somme de deux fonctions.
 *
 * @author Nicolae
 */
public class Sum extends DefaultMap { 

	private Map f;
	private Map g;

	private double[] v1 = new double[2]; 
	private double[] v2 = new double[2]; 
	
	/**
	 * Cache le constructor standard.
	 */
	private Sum() {}
	
	/**
	 * Constructor qui initialise les deux applications.
	 *
	 * @param f application.
	 * @param f application.
	 */
	public Sum(Map f, Map g) {
		this.f = f;
		this.g = g;
	}

	/* (non-Javadoc)
	 * @see maths.DefaultMap#apply()
	 */
	protected void apply() {
		f.value(x, y, v1);
		g.value(x, y, v2);

		fx = v1[0] + v2[0];
		fy = v1[1] + v2[1];
	}

	/* (non-Javadoc)
	 * @see maths.DefaultMap#inverse()
	 */
	public Map[] inverse() {
		return null;
	}

	/* (non-Javadoc)
	 * @see maths.Map#differential()
	 */
	public void compDiff() {
		Map df = f.differential();
		Map dg = g.differential();
		
		if(df == null || dg == null)
			der = null;
		else
			der = new Sum(df, dg);
	}
}
