target=condpar condineq conddiv

#include "header.inc"
#include "confparm.inc"
\text{outtype=int}	% int, double, unsigned int
\text{printftype=%d}	% corresponding to outtype
\text{inttype=all}	% generated integer: all or pos
\text{zeros=yes}	% include zeros in list
\integer{limit=20}	% integer size limit: power of 2
\integer{sizelim1=3}	% smallest list
\integer{sizelim2=1000}	% biggest list
\text{size=10x70}	% textarea size
			% sizes of testing lists
\integer{decal=randint(0..4)}
\text{ns=wims(values x for x in 
	 3,4,5+\decal,6+\decal,7+\decal,8+\decal,9+\decal,10+\decal,
	 randint(10..20),randint(20..50),randint(50..100),
	 randint(100..200),randint(800..1000))}
\integer{ncnt=items(\ns)}
\text{wt=sum}

\text{sh=shuffle(25)}
\integer{c1=\sh[1]*random(1,-1)}
\integer{c2=\sh[2]*random(1,-1)}
\text{summand=the sum of <tt>\cc*\ll[][\ii]</tt>}

#if #TARGET (condpar)
 \title{Conditional coeff by parity}
 \text{data=randomrow(x[k]-1,\ii
		      y[k],\ll[][\ii]
		      x[k]+y[k]-1,\ii+\ll[][\ii]
		      x[k]-y[k]-1,\ii-\ll[][\ii]
		      (x[k]-1)*y[k],\ii*\ll[][\ii]
		      (x[k]-1)*y[k],\ll[][\ii]*\ii
)}
 \text{wherelist=<tt>\cc = \c1</tt> if <tt>\data[2]</tt> is odd,
	<tt>\cc = \c2</tt> if <tt>\data[2]</tt> is even}
 \text{formula=(\data[1])%2}
#endif

#if #TARGET (condineq)
 \title{Conditional coeff by inequality}
 \integer{p1=randint(2..50)}
 \integer{p2=randint(-100..100)}
 \text{dir=randomrow(\(<),\(>=),min
		     \(>),\(<=),max
)}
 \text{data=randomrow(x[k]-1,\ii,\p1
		      y[k],\ll[][\ii],\p2
		      x[k]+y[k]-1,\ii+\ll[][\ii],\p2
		      x[k]-y[k]-1,\ii-\ll[][\ii],\p2
		      (x[k]-1)*y[k],\ii*\ll[][\ii],\p2
		      (x[k]-1)*y[k],\ll[][\ii]*\ii,\p2
)}
 \text{wherelist=<tt>\cc = \c1</tt> if <tt>\data[2] \dir[1] \data[3]</tt>,
	<tt>\cc = \c2</tt> if <tt>\data[2] \dir[2] \data[3]</tt>}
 \text{formula=\dir[3](\data[1]-(\data[3]),0)}
#endif

#if #TARGET (conddiv)
 \title{Conditional coeff by divisibility}
 \integer{div=random(3..15)}
 \text{data=randomrow(x[k]-1,\ii
		      y[k],\ll[][\ii]
		      x[k]+y[k]-1,\ii+\ll[][\ii]
		      x[k]-y[k]-1,\ii-\ll[][\ii]
		      (x[k]-1)*y[k],\ii*\ll[][\ii]
		      (x[k]-1)*y[k],\ll[][\ii]*\ii
)}
 \text{wherelist=<tt>\cc = \c1</tt> if <tt>\data[2]</tt> is not divisible by \div,
	<tt>\cc = \c2</tt> if <tt>\data[2]</tt> is divisible by \div}
 \text{formula=(\data[1])%\div}
#endif

\text{sum=}
\text{listsc=}
\for{n in \ns}{
 #include "list.inc"
 \text{listsc=wims(append item { \list } to \listsc)}
 \text{slib=slib(\selmeth \n,\wt,,\list)}
 \text{listsel=wims(line 1 of \slib)}
 \text{condition=wims(line 2 of \slib)}
 \text{n=items(\listsel)}
 \if{\n > 0}{
  \text{list2=item(\listsel,\list)}
  \text{sum1=wims(sum x for x in \list2)}
  \text{none=pari(x=[\listsel];y=[\list2];)}
  \text{test=pari(vector(\n,k,\formula))}
  \text{sum2=wims(sum x for x in item(positionof(0,\test),\list2))}
  \integer{sum1=(\c1)*(\sum1)+(\c2-(\c1))*(\sum2)}
  \text{sum=\sum \sum1}
 }{
  \text{sum=\sum 0}
 }
}
\text{where=where wims(replace internal , by , et \null in shuffle(\wherelist))}

#include "src.inc"
#include "main.inc"

