target=trapeze0 trapezeintru trapeze1 trapeze2 trapezecadre

#include "xiao.inc"
  
#if #TARGET (trapeze0)
# define ERR 0
# define INTRUS 0
 \title{Trapze basique}
 \integer{intrus=0}
#endif
#if #TARGET (trapezeintru)
# define ERR 0
# define INTRUS 1
 \title{Trapze avec intrus}
 \integer{intrus=random(0,1,2,3)}
#endif
#if #TARGET (trapeze1)
# define ERR 1
# define INTRUS 0
 \title{Trapze et erreur I}
 \integer{intrus=0}
#endif
#if #TARGET (trapeze2)
# define ERR 2
# define INTRUS 0
 \title{Trapze et erreur II}
 \integer{intrus=0}
#endif
#if #TARGET (trapezecadre)
# define ERR 3
# define INTRUS 0
 \title{Trapze encadr}
 \integer{intrus=0}
#endif

\integer{err=ERR}
#if ERR == 3
\real{der1=randint(7..20)}
\real{der2=randint(7..20)}
\integer{cuts=random(5..7)}
#else
\real{der1=randint(10..60)/10}
\real{der2=randint(10..60)/10}
\integer{cuts=random(6..10)}
#endif
#include "cut.inc"
\real{sum=wims(sum x for x in \cutvalues1)}
\real{sum=\sum-((\cutvalues[1]+\cutvalues[-1])/2)}
\real{int=\sum*((\b)-(\a))/\cuts}
\real{dermax=max(\der1,\der2)}
\real{error=(\b-\a)^3*\dermax/(12*\cuts^2)}
\real{bi=\int-\error}
\real{bs=\int+\error}

#if ERR == 0
 \steps{r1}
#else
# if ERR == 3
 \steps{r3,r4}
# else
 \steps{r1
r2}
# endif
#endif

\statement{Voici quelques valeurs d'une fonction \(f) infiniment drivable.
 <p><center>
 <table border=2>
 <tr><th>\(x)
 \for{i=1 to \cutcnt}{<td nowrap align=center>\cutpoints[\i]</td>}
 <tr><th>\(f(x))
 \for{i=1 to \cutcnt}{<td nowrap align=center>\cutvalues[\i]</td>}
 </table></center> <p>
#if ERR == 3
 Etant donn l'estimation \(|f''(x)| < \dermax) pour \(x) \in [\a,\b], donnez un encadrement de
l'intgrale dfinie \(int(f(x),x=\a..\b)) par la mthode des trapzes 
intervalles rguliers :
<p><center>
 \embed{r3,8} &lt; \(int(f(x),x=\a..\b)) &lt; \embed{r4,8}
</center> <p>
#else
 \if{\step=1}{
 Utilisez ces valeurs pour calculer l'intgrale dfinie \(int(f(x),x=\a..\b))
 par la mthode des trapzes  intervalles rguliers.
 \if{INTRUS > 0}{(Attention aux valeurs intrues ventuelles !)}
 }{
  La mthode des trapzes donne une intgration approximative
  <p><center>
  \(int(f(x),x=\a..\b) = \int).
  </center> <p>
  \if{\err=1}{Sachant que \(|f''(x)| < \dermax) pour \(x) \in [\a,\b],}
  {Sachant que \( -\der1 < f''(x) < \der2 ) pour \(x) \in [\a,\b],}
  donnez une borne d'erreur de cette approximation.
  <p> <center>
   \(| \int - int(f(x),x=\a..\b) |) &lt; \embed{r2,8}
  </center>
 }
#endif
}

\reply{L'intgrale numrique}{\int}{type=number}
\reply{Borne d'erreur}{\error}{type=number}
\reply{Borne infrieure}{\bi}{type=number}
\reply{Borne suprieure}{\bs}{type=number}

#if ERR > 0
 \hint{L'estimation d'erreur pour la mthode des trapzes est la suivante :
<p> <center>
\(| T_n - int(f(x),x=a..b) |) \le \((b-a)^3*M_2/(12*n^2)) ,
</center> <p>
o \(n) est le nombre de coupes, \(M_2) un majorant de \(|f''(x)|) pour \(x
\in [a,b]), et \(T_n) l'approximation des trapzes.
}
#endif