target= cram01 cram02 cramcorr01 crammol01 crammolcorr01

\author{Bernadette Perrin-Riou} 
\email{bernadette.perrin-riou@math.u-psud.fr}

#if #TARGET(cram01)
 \title{Reprsentation de Cram 01}
#endif

#if #TARGET(cram02)
  \title{Reprsentation de Cram 02}
#endif

#if #TARGET(cramcorr01)
  \title{Reprsentation de Cram 03}
#endif

#if #TARGET(crammol01)
  \title{Gomtrie molculaire 01}
#endif

#if #TARGET(crammolcorr01)
  \title{Gomtrie molculaire 02}
#endif

\text{angle=pi/24}
text{h=1.3}
\real{cos=cos(\angle)}
\real{sin=sin(\angle)}
\text{Ftriangle=ftriangle 0,0,\cos, -\sin,\cos,\sin,black}
\text{Dtriangle1=triangle 0,0,\cos, -\sin,\cos,\sin,yellow}
\text{Dtriangle2=hatchfill 2*\cos/3,0,5,0,0,black}
\text{Dtriangle3=transparent yellow}

\text{mol=A,X1,X2,X3,X4,X5,X6,X7}

\matrix{M=1,3,6,10
2,5,9
4,8,13
7,12,11
}

correspondance
\matrix{typeCram=AX_2,AX_2E,AX_2E_2,AX_2E_3
AX_3,AX_3E,AX_3E_2
AX_4,AX_4E,AX_4E_2
AX_5,AX_5E,AX_6
}

tirage du type VSEPR
\text{i=randint(1..4)}

#if #TARGET(cram02)
on ne considre pas les molcules AX2EN car trop d'ambiguts
\text{i=randint(2..4)}
#endif

dtermination de la figure correspondante
\if{\i=1}{\text{j=randint(1..4)}}{\text {j=randint(1..3)}}
\text{jvrai=\j}
\if{\j=4}{\text{jvrai=1}}

cration de la variable TYPE ou MOL pour l'analyse de rponse
#if #TARGET(cram01) 
\text{TYPE=\typeCram[\i;\j]}
#endif

#if #TARGET(cram02) || #TARGET(cramcorr01)
\text{TYPE=\(\typeCram[\i;1])}
\if {\i=1}{\text {TYPE=random(\(AX_2),\(AX_2E_3))}}
\for{k=2 to 3}{\text{TYPE=\TYPE,\(\typeCram[\i;\k])}}
\text{TYPE=wims(nonempty items \TYPE)}
#endif


#if #TARGET(crammolcorr01)
*** tirage des molcules  afficher **************
\text{molchoix=}
\integer{col=1}
\if{\i=1}{\integer{col=random(1,4)}}
\text{ligne=\M[\i;\col]}
\text{MOL=wims(record \ligne of typeAX1C)}
\integer{nb=wims(linecnt \MOL)}
\integer{choix=randint(2..\nb)}
\text{liste=row(\choix,\MOL)}
\text{molecule=\liste[1]}
\text{molchoix=\molchoix,\(\molecule)}
\for{col=2 to 3}{
   \text{ligne=\M[\i;\col]}
   \text{MOL=wims(record \ligne of typeAX1C)}
   \integer{nb=wims(linecnt \MOL)}
   \integer{choix=randint(2..\nb)}
   \text{liste=row(\choix,\MOL)}
   \text{molecule=\liste[1]}
   \text{molchoix=\molchoix,\(\molecule)}
   }
\text{molchoix=wims(nonempty items \molchoix)}
#endif

#if #TARGET(crammol01) 
\text{ligne=\M[\i;\j]}
\text{MOL=wims(record \ligne of typeAX1C)}
\integer{nb=wims(linecnt \MOL)}
\integer{choix=random(2..\nb)}
\text{liste=row(\choix,\MOL)}
\text{molecule=\liste[1]}
\if{\i=4}{\text{mol=wims(replace item number 7 by F in \mol)}}
\for{k=1 to 6}{
     \integer{point=\k+1}
     \text{mol=wims(replace item number \k by \liste[\point] in \mol)}
     }
#endif

affichage du dessin 
#if #TARGET(cram01) || #TARGET(cramcorr01) || #TARGET(crammol01) || #TARGET(crammolcorr01)
\text{dessin=}
\for{u=1 to 3}{
   \text{h=\M[\i;\u]}
   \text{dessin1=wims(record \h of dessinCram)}
   \text{dessin1=randitem(\dessin1)}
   \text{dessin1=wims(declosing \dessin1)}
   \for{s=1 to 7}{
      \text{dessin1=wims(replace internal mol[\s] by \mol[\s] in \dessin1)}
      }
   \text{dessin1=wims(replace internal Ftriangle by \Ftriangle in \dessin1)}
   \text{dessin1=wims(replace internal Dtriangle1 by \Dtriangle1 in \dessin1)}
   \text{dessin1=wims(replace internal Dtriangle2 by \Dtriangle2 in \dessin1)}
   \text{dessin1=wims(replace internal Dtriangle3 by \Dtriangle3 in \dessin1)}
   \text{dessin1=draw(150,150
   \dessin1)}
   \text{dessin=\dessin, <img src="\dessin1"}
  }
\text{dessin=wims(nonempty items \dessin)}
#endif

#if #TARGET(cram02)
   \text{h=\M[\i;\jvrai]}
   \text{dessin1=wims(record \h of dessinCram)}
   \text{dessin1=randitem(\dessin1)}
   \text{dessin1=wims(declosing \dessin1)}
   \for{s=1 to 7}{
      \text{dessin1=wims(replace internal mol[\s] by \mol[\s] in \dessin1)}
      }
   \text{dessin1=wims(replace internal Ftriangle by \Ftriangle in \dessin1)}
   \text{dessin1=wims(replace internal Dtriangle1 by \Dtriangle1 in \dessin1)}
   \text{dessin1=wims(replace internal Dtriangle2 by \Dtriangle2 in \dessin1)}
   \text{dessin1=wims(replace internal Dtriangle3 by \Dtriangle3 in \dessin1)}
   \text{dessin1=draw(150,150
   \dessin1)}
   \text{dessin=<img src="\dessin1">}
#endif

affichage du texte et analyse de la rponse
#if #TARGET(cram01)
\statement {Reprsentation de Cram versus type VSEPR.<br>
<i>Niveau de difficult 2</i><br>
Soit une molcule de type VSEPR \(\TYPE). Parmi les reprsentations de Cram proposes, cliquez sur celle correspondant  ce type.
<p align="center">\embed{reply1}</p>
}
\answer{}{\jvrai;\dessin}{type=click}
#endif

#if #TARGET(cram02)
\statement {type VSEPR versus reprsentation de Cram.<br>
<i>Niveau de difficult 1</i><br>
Soit une molcule dont la reprsentation de Cram est affiche ci-dessous. Cliquez sur le type VSEPR correspondant  cette gomtrie.
<p align="center">\dessin</p>
<p align="center">\embed{reply1}</p>
}
\answer{}{\jvrai;\TYPE}{type=radio}
#endif

#if #TARGET(cramcorr01)
\statement{Type VSEPR versus Reprsentation de Cram<br>
<i>Difficult 1</i><br>
Faites correspondre les reprsentations de Cram proposes avec leur type VSEPR, en cliquant sur le type VSEPR puis sur la reprsentation associe.<br>
<p align="center">\embed{reply1,150x150x150}</p>
}
\answer{}{\dessin;\TYPE}{type=correspond}
\feedback{1=1}{La rponse est 
<table align="center">
<tr><td align="center">\dessin[1] </td><td align="center">\TYPE[1]</td></tr>
<tr><td align="center">\dessin[2] </td><td align="center">\TYPE[2]</td></tr>
<tr><td align="center">\dessin[3]</td><td align="center">\TYPE[3]</td></tr>
</table>
}
#endif

#if #TARGET(crammol01)
\statement {Reprsentation de Cram versus type VSEPR.<br>
<i>Niveau de difficult 2</i><br>
Soit la molcule \(\molecule). Parmi les reprsentations de Cram proposes, cliquez sur celle correspondant  sa gomtrie.
<p align="center">\embed{reply1}</p>
<i>Pour dterminer la gomtrie de la molcule, on considrera la forme de Lewis ne prsentant pas de charges formelles.</i>}
\answer{}{\jvrai;\dessin}{type=click}
#endif

#if #TARGET(crammolcorr01)
\statement{Type VSEPR versus Reprsentation de Cram<br>
<i>Difficult 3</i><br>
Donnez la gomtrie de chacune des molcules proposes en cliquant le nom de la molcule puis sur sa reprsentation de Cram.<br>
<i>Pour dterminer la gomtrie des molcules, on considrera leur forme de Lewis ne prsentant pas de charges formelles.</i><br>
<p align="center">\embed{reply1,150x150x150}</p>
}

\answer{}{\dessin;\molchoix}{type=correspond}
\feedback{1=1}{La rponse est 
<p>
<table align="center">
<tr><td align="center">\dessin[1]</td><td align="center">\molchoix[1]</td></tr>
<tr><td align="center">\dessin[2]</td><td align="center">\molchoix[2]</td></tr>
<tr><td align="center">\dessin[3]</td><td align="center">\molchoix[3]</td></tr>
</table>
}
#endif