target= repul1 repul2

\author{Cherfouh Nama et Marie-jolle Ramage}
\email{marie-joelle.ramage@didasco.u-psud.fr}

#if #TARGET(repul1)
\title{Atomes et doublets non-liants}
#endif 

#if #TARGET(repul2)
\title{Gomtrie des molcules  1 centre}
#endif 

\text{rangex=-1.5,1.5}
\text{rangey=-1.5,1.5}
\real{SIZEX=300}
\real{SIZEY=300}
\text{taille=20 x 20}

\matrix{typeVSEPR=AX2 E
AX3 E,AX2 E2
AX4 E,AX3 E2,AX2 E3
AX5 E,AX4 E2}

** tirage alatoire de la figure ***
\integer{ifig=random(1..4)}
** nombre de points  rcuprer **
\integer{N=\ifig+3}

** rcupration des types VSEPR correspondants  la figure ***
\integer{j=random(1..\ifig)}
\if{\ifig=4}{\integer {j=random(1..2)}}
\text{TYPE=\typeVSEPR[\ifig;\j]}

** dfinition de la matrice des solutions pour chaque type VSEPR **
\if{\TYPE=AX2 E}
{\matrix{sol=X X :
X : X
: X X
}}

\if{\TYPE=AX3 E}
{\matrix{sol=X X X :
X X : X
X : X X
: X X X
}}


\if{\TYPE=AX2 E2}
{\matrix{sol=X X : :
X : X :
X : : X
: : X X
: X X :
: X : X
}}

\if{\TYPE=AX4 E}
{\matrix{sol=: X X X X
X : X X X
X X : X X
}}

\if{\TYPE=AX3 E2}
{\matrix{sol=: : X X X
X : : X X
: X : X X
}}

\if{\TYPE=AX2 E3}
{\matrix{sol=: : : X X}}

\if{\TYPE=AX5 E}
{\matrix{sol=: X X X X X
X : X X X X
X X : X X X
X X X : X X
X X X X : X
X X X X X :
}}

\if{\TYPE=AX4 E2}
{\matrix{sol=X X X X : :
X : X : X X
: X : X X X
}}

**rcupration des points  afficher **
\matrix {xpoint=wims (record \ifig of points)}

** cration de la figure ***
\text{figure=wims(record \ifig of figure2)}
\text{dessin=draw(\SIZEX, \SIZEY
\figure)}

** affichage des cases  cocher **
#if #TARGET(repul1)
\text{good=A,X,:}
#endif

#if #TARGET(repul2)
** tirage de la molcule **
\matrix{M=3
5,6
8,9,10
12,13}

\text{ligne=\M[\ifig;\j]}
\text{MOL=wims(record \ligne of typeAX1C)}
\integer{nb=wims(linecnt \MOL)}
\integer{choix=random(2..\nb)}
\text{liste=row(\choix,\MOL)}
\text{molecule=\liste[1]}
\text{centre=\liste[2]}

** rcupration du nom de la molcule **
\text{ouverture=wims(record 0 of 1centre)}
\integer{nb=wims(linecnt \ouverture)}
\for{k=2 to \nb}
{\if{\ouverture[\k;1] issamecase \molecule}
    {\text{nom=\ouverture[\k;3]}}}
\text{denom=slib(lang/frapostrophe de \nom)}

** affichage des cases  cocher : matrice good **
\text{good=0,0,0,0,0,0,0,:}
\for{k=1 to 7}{
     \integer{point=\k+1}
     \text{good=wims(replace item number \k by \liste[\point] in \good)}
     }
#endif

** cration de la matrice position ***
\matrix{position=}
\for {i=1 to \N}{
   \text{p=\xpoint[\i;1],\xpoint[\i;2]}
  \text{pos=slib(draw/convpixel \p ,\SIZEX,\SIZEY,\rangex,\rangey,10,pixels)}
  \matrix{position=\position
           r \i,\pos[1]x\pos[2]}
}

\text{STEP=r1,r2,r3,r4,r5,r6,r7}
\text{STEP=item([1..\N],\STEP)}
\steps{\STEP}

#if #TARGET(repul1)
\statement{<br><i>Difficult 1</i><p>
Soit une molcule de type VSEPR \(\TYPE). Placez sur la figure ci-dessous 
l'atome \(A), les atomes \(X) et les doublets lectroniques non-liants ( : ).
<p> Pour cela, slectionnez votre image (A , X ,  : ) par un click de 
souris, puis positionnez-la en cliquant sur le point d'interrogation 
correspondant  la position qui vous semble correcte.
<br>
  <p align="center">
    \special{imagefill \dessin,\SIZEX x \SIZEY, \taille
    \position}
  </p>
}
\answer{}{A;\good[]}{type=clickfill}
#endif

#if #TARGET(repul2)
\statement{<br><i>Difficult 1</i><p>
La molcule \denom de symbole chimique \(\molecule) est de type \(\TYPE). Placez sur la figure ci-dessous 
les atomes et les doublets lectroniques non-liants ( : ).
<p> Pour cela, slectionnez votre image  placer par un click de 
souris, puis positionnez-la en cliquant sur le point d'interrogation 
correspondant  la position qui vous semble correcte.
<br>
  <p align="center">
    \special{imagefill \dessin,\SIZEX x \SIZEY, \taille
    \position}
  </p>
}
\answer{}{\centre ;\good[]}{type=clickfill}
#endif

\answer{}{\rep2}{type=clickfill}
\answer{}{\rep3}{type=clickfill}
\answer{}{\rep4}{type=clickfill}
\answer{}{\rep5}{type=clickfill}
\answer{}{\rep6}{type=clickfill}
\answer{}{\rep7}{type=clickfill}

\matrix{rep=\rep2
\rep3
\rep4
\rep5
\rep6
\rep7}

**concatnation des repi**
#if #TARGET(repul1)
\text{R=\rep2}
\for {i=2 to \N-1}{
\text{R=wims( append word \rep[\i;] to \R)}**
}
#endif

#if #TARGET(repul2)
\text{R=}
\for {i=1 to \N-1}{
\text{atome=\rep[\i;]}
\if{\atome issamecase :}{\text{R=wims( append word \atome to \R)}}
{\text{R=wims( append word X to \R)}}
}
#endif

\text{test=0}
\if{\TYPE=AX2 E and ( \R issametext \sol[1;] or \R issametext \sol[2;] or \R issametext \sol[3;])}
{\text{test=1}}


\if{\TYPE=AX3 E and ( \R issametext \sol[1;] or \R issametext \sol[2;] or \R issametext \sol[3;] or \R issametext \sol[4;])}
{\text{test=1}}

\if{\TYPE=AX2 E2 and ( \R issametext \sol[1;] or \R issametext \sol[2;] or \R issametext \sol[3;] or \R issametext \sol[4;] or \R issametext \sol[5;] or \R issametext \sol[6;])}
{\text{test=1}} 

\if{\TYPE=AX4 E and ( \R issametext \sol[1;] or \R issametext \sol[2;] or \R issametext \sol[3;])}
{\text{test=1}}

\if{\TYPE=AX3 E2 and ( \R issametext \sol[1;] or \R issametext \sol[2;] or \R issametext \sol[3;])}
{\text{test=1}}

\if{\TYPE=AX2 E3 and ( \R issametext \sol[1;])}
{\text{test=1}}

\if{\TYPE=AX5 E and ( \R issametext \sol[1;] or \R issametext \sol[2;] or \R issametext \sol[3;] or \R issametext \sol[4;] or \R issametext \sol[5;] or \R issametext \sol[6;])}
{\text{test=1}}

\if{\TYPE=AX4 E2 and ( \R issametext \sol[1;] or \R issametext \sol[2;] or \R issametext \sol[3;])}
{\text{test=1}}



\condition{Position des doublets et des atomes terminaux}{\test=1}
