target=basicC basicL parallelrc parallelrl serialrc serialcr serialrl seriallr

#include "xiao.inc"
\text{A=}

#if #TARGET (basicC)
  \title{1 - capacitor}
  \text{ctype=5/closeser}
  \text{comp=acsrc @S,wire,iArrow @@I,,cap _CL_}
  \text{lctype=c}
  \text{f_a1=v1/imped}
  \text{f_v2=v1}
  \text{f_a2=a1}
  \text{f_ph1=90}
  \text{f_ph2=0}
  \text{noask=R}
#endif
  
#if #TARGET (basicL)
  \title{1 - coil}
  \text{ctype=5/closeser}
  \text{comp=acsrc @S,wire,iArrow @@I,,coilR _CL_}
  \text{lctype=l}
  \text{f_a1=v1/imped}
  \text{f_v2=v1}
  \text{f_a2=a1}
  \text{f_ph1=90}
  \text{f_ph2=0}
  \text{noask=R}
#endif
  
#if #TARGET (parallelrc)
  \title{2 - parallel RC}
  \text{ctype=5/closeparr}
  \text{lctype=c}
  \text{comp=acsrc @S,iArrow @@I,res _R_,,cap _CL_}
  \text{f_a1=v1*sqrt(1/imped^2+1/r^2)}
  \text{f_v2=v1}
  \text{f_a2=v1/imped}
  \text{f_ph1=atan(r/imped)*180/pi}
  \text{f_ph2=0}
  \text{noask=}
#endif
  
#if #TARGET (parallelrl)
  \title{2 - parallel RL}
  \text{ctype=5/closeparr}
  \text{lctype=l}
  \text{comp=acsrc @S,iArrow @@I,res _R_,,coilR _CL_}
  \text{f_a1=v1*sqrt(1/imped^2+1/r^2)}
  \text{f_v2=v1}
  \text{f_a2=v1/imped}
  \text{f_ph1=atan(r/imped)*180/pi}
  \text{f_ph2=0}
  \text{noask=}
#endif
  
#if #TARGET (serialrc)
  \title{2 - serial RC}
  \text{ctype=7/closeser}
  \text{lctype=c}
  \text{comp=wire,acsrc @S,wire,iArrow @@I,chas,res _R_,cap _CL_}
  \text{A=12,5.5}
  \text{f_a1=v1/sqrt(imped^2+r^2)}
  \text{f_v2=v1*imped/sqrt(imped^2+r^2)}
  \text{f_a2=a1}
  \text{f_ph1=atan(imped/r)*180/pi}
  \text{f_ph2=0}
  \text{noask=}
#endif
  
#if #TARGET (serialcr)
  \title{2 - serial CR}
  \text{ctype=7/closeser}
  \text{lctype=c}
  \text{comp=wire,acsrc @S,wire,iArrow @@I,chas,cap _CL_,res _R_}
  \text{A=12,5.5}
  \text{f_a1=v1/sqrt(imped^2+r^2)}
  \text{f_v2=v1*r/sqrt(imped^2+r^2)}
  \text{f_a2=a1}
  \text{f_ph1=atan(imped/r)*180/pi}
  \text{f_ph2=0}
  \text{noask=}
#endif
  
#if #TARGET (serialrl)
  \title{2 - serial RL}
  \text{ctype=7/closeser}
  \text{lctype=l}
  \text{comp=wire,acsrc @S,wire,iArrow @@I,chas,res _R_,coilR _CL_}
  \text{A=12,5.5}
  \text{f_a1=v1/sqrt(imped^2+r^2)}
  \text{f_v2=v1*imped/sqrt(imped^2+r^2)}
  \text{f_a2=a1}
  \text{f_ph1=atan(imped/r)*180/pi}
  \text{f_ph2=0}
  \text{noask=}
#endif
  
#if #TARGET (seriallr)
  \title{2 - serial LR}
  \text{ctype=7/closeser}
  \text{lctype=l}
  \text{comp=wire,acsrc @S,wire,iArrow @@I,chas,coil _CL_,res _R_}
  \text{A=12,5.5}
  \text{f_a1=v1/sqrt(imped^2+r^2)}
  \text{f_v2=v1*r/sqrt(imped^2+r^2)}
  \text{f_a2=a1}
  \text{f_ph1=atan(imped/r)*180/pi}
  \text{f_ph2=0}
  \text{noask=}
#endif
  
#include "data.inc"
#include "confparm.inc"
#include "process.inc"

\text{vide=}

\text{pre=In the circuit on the right, the source S is a sinusoidal alternate voltage}
\text{pre=f iswordof \given?\pre \freq}
\text{pre=v1 iswordof \given?\pre of \v1 volts RMS}

\text{known=a1 iswordof \given?the current intensity I = \a1 \Aunit:}
\text{known=a2 iswordof \given?wims(append item \vide the current intensity
going through R is \a2 \Aunit to \known)}
\text{known=v2 isin \given?wims(append item \vide the voltage on point A
is \v2 V to \known)}
\if{ph1 iswordof \given}{
 \if{ph1>0}{
  \text{add=the phase of the current I advances by \ph1&deg; that of the
voltage}
 }{
  \real{ph=-(\ph1)}
  \text{add=the phase of the current courant I lags behind by \ph&deg; that
of the voltage}
 }
 \text{known=wims(append item \vide \add to \known)}
}

\statement{
    <img align=right hspace=10 src=\circ> <p>
\if{\known notsametext }{
 \pre, \known.
}{
 \pre.
}
<p>What is \quest&nbsp;? 
\embed{r1,8}\qunit
<p>
ATTENTION. The error tolerance for your reply is \tolerance%.

<br clear=right>
}

\answer{\quest}{\good}{type=range}

\feedback{(\reply1 > \good2 and \reply1<=\good4) or
(\reply1 < \good1 and \reply1 >= \good3)}{Pay attention to the error tolerance!
Your seem to have made an error exceeding the tolerance in your computation.
}

