target=ortho2dpts ortho2deq ortho2dparm

#include "header.inc"
\integer{dim=2}
#include "oneeq.inc"

#if #TARGET (ortho2dpts)
 \title{Orthogonal 2D by points}
#endif
#if #TARGET (ortho2deq)
 \title{Orthogonal 2D by equation}
#endif
#if #TARGET (ortho2dparm)
 \title{Orthogonal 2D parametric}
 \function{xparm=\x1 + \b*t}
 \function{yparm=\y1 - \a*t}
#endif

\function{eqperp=\b*x - \a*y}
\integer{d0=\b*(\x0) - \a*(\y0)}

\statement{Find an equation of the line in \(RR^\dim) 
passing through the point \((\x0 , \y0)) and orthogonal to the line
#if #TARGET (ortho2deq)
 defined by the equation
 <p><center>
 \(\eq = \d).
 </center>
#endif
#if #TARGET (ortho2dpts)
 determined by the points
 <p><center>
 \((\x1 , \y1)) and \((\x2 , \y2)).
 </center>
#endif
#if #TARGET (ortho2dparm)
 defined by the parametric system
 <p><center>
 \(x = \xparm) , \(y = \yparm) .
 </center>
#endif
}

\answer{The orthogonal line}{\eqperp = \d0}

