target=parallel2dpts parallel2deq parallel2dparm

#include "header.inc"
\integer{dim=2}
#include "oneeq.inc"

#if #TARGET (parallel2dpts)
 \title{Parallel 2D by points}
#endif
#if #TARGET (parallel2deq)
 \title{Parallel 2D by equation}
#endif
#if #TARGET (parallel2dparm)
 \title{Parallel 2D parametric}
 \function{xparm=\x1 + \b*t}
 \function{yparm=\y1 - \a*t}
#endif

\integer{d0=\a*(\x0) + \b*(\y0) + \c*(\z0)}

\statement{Find an equation de the line in \(RR^\dim) 
passing through the point \((\x0 , \y0)) and is parallel to the line
#if #TARGET (parallel2deq)
 defined by the equation
 <p><center>
 \(\eq = \d).
 </center>
#endif
#if #TARGET (parallel2dpts)
 determined by the points
 <p><center>
 \((\x1 , \y1)) and \((\x2 , \y2)).
 </center>
#endif
#if #TARGET (parallel2dparm)
 defined by the parametric system
 <p><center>
 \(x = \xparm) , \(y = \yparm) .
 </center>
#endif
}

\answer{The parallel line}{\eq = \d0}

