target=parallel3dpts parallel3deq parallel3dparm

#include "header.inc"
\integer{dim=3}
#include "oneeq.inc"

#if #TARGET (parallel3dpts)
 \title{Parallel 3D - plane by points}
#endif
#if #TARGET (parallel3deq)
 \title{Parallel 3D - plane by equation}
#endif
#if #TARGET (parallel3dparm)
 \title{Parallel 3D - plane parametric}
 \function{xparm=\x1 + \b*t}
 \function{yparm=\y1 - \a*t}
#endif

\integer{d0=\a*(\x0) + \b*(\y0) + \c*(\z0)}

\statement{Find an equation of the plane in \(RR^\dim) 
passing through the point \((\x0 , \y0 , \z0)) and parallel to the plane
#if #TARGET (parallel3deq)
 defined by the equation
 <p><center>
 \(\eq = \d).
 </center>
#endif
#if #TARGET (parallel3dpts)
 determined by the points
 <p><center>
 \((\x1 , \y1 , \z1)) , \((\x2 , \y2 , \z2)) and \((\x3 , \y3 , \z3)).
 </center>
#endif
#if #TARGET (parallel3dparm)
 defined by the parametric system
 <p><center>
 \(x = \xparm) , \(y = \yparm) .
 </center>
#endif
}

\answer{The parallel line}{\eq = \d0}

