target=somarete1 somarete2 somarete3

\integer{n=\confparm1=?randint(5..6)}
\integer{n=\confparm1=1?randint(5..6)}
\integer{n=\confparm1=2?randint(6..9)}
\integer{n=\confparm1=3?randint(10..12)}

#if #TARGET (somarete1)
 \title{Sommets et artes d&#39;un graphe simple}
 \author{Romain BOILLAUD}
\email{Romain.Boillaud@wanadoo.fr}
#endif

#if #TARGET (somarete2)
 \title{Sommets et artes d&#39;un graphe }
 \author{Bernadette PERRIN-RIOU}
\email{bpr@math.u-psud.fr}
#endif

#if #TARGET (somarete3)
 \title{Listes d'adjacence}
 \author{Bernadette PERRIN-RIOU}
\email{bpr@math.u-psud.fr}
#endif

\language{fr}
\range{-30..30}
\computeanswer{no}
\format{html}
\precision{10000}
\integer{s=randint(1..\n)}

\integer{m=randint(2*\n, min(3*\n, \n*(\n-1)/2))}
\text{liste=wims(values 1 for x=1 to \m)}

#if #TARGET (somarete1)
\text{liste0=wims(values 0 for x=1 to \n*(\n-1)/2 -\m)}
\text{liste=shuffle(\liste,\liste0)}
\matrix{G=pari(n=\n; liste=[\liste];
M=matrix(n,n,i,j,if(i<j, liste[n*(n-1)/2-(n-i+1)*(n-i)/2 +j-i]));
M=matrix(n,n,i,j,if(i<j,M[i,j],M[j,i]));print(M))}
#endif

#if #TARGET (somarete2) ||  #TARGET (somarete3)
\text{liste0=wims(values 0 for x=1 to \n^2 -\m)}
\text{liste=shuffle(\liste,\liste0)}
\matrix{G=pari(n=\n; liste=[\liste];
matrix(n,n,i,j,liste[n*(i-1) +j ]))}
#endif

#if #TARGET (somarete1)
\integer{a=0}
\integer{d=0}
\for{i=1 to \n}{
	\for{j=1 to \n}{
		\integer{u=item(\j,row(\i,\G))}
		\if{\u=1}{\integer{a=\a+1}
				\if{\i=\s}{\integer{d=\d+1}}}}}
\integer{a=\a/2}

\text{dessin=slib(graph/draw [\G])}

\steps{reply1, reply2
reply3}

\statement{On considre le graphe reprsent ci-dessous. 
<p> <center> \draw{200,200}{\dessin} </center>
\if{\step=1}{<p> Combien y a-t-il de sommets dans ce graphe ?
<p> Combien y a-t-il d&#39;artes dans ce graphe ?}
\if{\step=2}{<p> Quel est le degr du sommet \s ?}
}

\answer{Nombre de sommets}{\n}{type = numeric}
\answer{Nombre d&#39;artes}{\a}{type = numeric}
\feedback{\reply2 <> \a}{Lorsque le nombre d&#39;artes d&#39;un graphe \(G = (V, E)) est lev, on peut, pour le dterminer, utiliser le principe des bergers. Pour cela, on compte le nombre d&#39;extrmits d&#39;artes, c&#39;est--dire la somme des degrs des sommets, que l&#39;on divise par 2. Cela revient  utiliser la formule 
<center> \(\sum_{v \in V}deg(v) = 2|E|\), </center>
o deg(v) dsigne le degr d&#39;un sommet \(v)  dans\( V).}
\answer{Degr du sommet \s}{\d}{type = numeric}

#endif

#if #TARGET (somarete2)
\integer{a=0}
\integer{d=0}
\integer{degs=0}
\integer{dege=0}
\for{i=1 to \n}{\integer{a=\a+\G[\i;\i]}
\integer{degs=\degs+\G[\s;\i]}
\integer{dege=\dege+\G[\i;\s]}
}


\text{dessin=slib(graph/draw [\G])}

\steps{reply1, reply2
reply3,reply4}

\statement{On considre le graphe orient reprsent ci-dessous :
<p> <center> \draw{200,200}{\dessin} </center>
\if{\step=1}{<p> Combien y a-t-il de sommets dans ce graphe ?
<p> Combien y a-t-il de boucles ?}

\if{\step=2}{<p> Quel est le degr sortant du sommet \s ?
 Quel est le degr rentrant du sommet \s ?}
}

\answer{Nombre de sommets}{\n}{type = numeric}
\answer{Nombre de boucles}{\a}{type = numeric}
\answer{Degr sortant du sommet \s}{\degs}{type = numeric}
\answer{Degr entrant du sommet \s}{\dege}{type = numeric}

#endif

#if #TARGET (somarete3)
\matrix{adj=}
\for{i=1 to \n}{
\text{u=position(1,\G[\i;])}
\text{cnt=items(\u)}
\text{u=\cnt=0 ? 0}
\matrix{adj=\adj
\u}
}


\text{dessin=slib(graph/draw [\G])}

\text{STEP=item(1..\n, r1,r2,r3,r4,r5,r6,r7,r8,r9,r10,r11,r12)}

\steps{\STEP}
\statement{On considre le graphe orient reprsent ci-dessous :
<p> <center> \draw{200,200}{\dessin} </center>
Pour chacun des sommets, donner la liste des sommets  que l'on peut atteindre directement en suivant une arte oriente : 
<p>
<table align="center" border=1 bgcolor="navajowhite"><tr align="center">
\for{k=1 to \n}{<th>\k</th>}
</tr><tr align="center">
 \for{k=1 to \n}{<td>\embed{\STEP[\k],8}</td>}</tr></table>
<p>
<b>Consigne</b> : Si une des listes des sommets, rentrer 0  la place.}

\answer{}{\adj[1;]}{type=set}
\answer{}{\adj[2;]}{type=set}
\answer{}{\adj[3;]}{type=set}
\answer{}{\adj[4;]}{type=set}
\answer{}{\adj[5;]}{type=set}
\answer{}{\adj[6;]}{type=set}
\answer{}{\adj[7;]}{type=set}
\answer{}{\adj[8;]}{type=set}
\answer{}{\adj[9;]}{type=set}
\answer{}{\adj[11;]}{type=set}
\answer{}{\adj[12;]}{type=set}
\answer{}{\adj[13;]}{type=set}
\answer{}{\adj[14;]}{type=set}
\answer{}{\adj[15;]}{type=set}
\answer{}{\adj[16;]}{type=set}
#endif


