target= eqdiff1 eqdiff2

\language{fr}
\range{-5..5}
\author{Bernadette Perrin-Riou, Wolfgang Steimle}
\email{bpr@math.u-psud.fr}
\computeanswer{yes}
\format{html}
\precision{10000}
#if #TARGET(eqdiff1)
\title{Equations diffrentielles 1}
#endif
#if #TARGET(eqdiff2)
\title{Equations diffrentielles 2}
#endif


\integer{N=randint(2..3)}
\integer{a3 = randint(0..2)}
\integer{a2 = randint(\a3+1..\a3+2)}
\integer{a1 = randint(\a2+1..\a2+2)}
\integer{a0 = randint(\a1+1..\a1+2)}


\function{A3 = simplify(x^\a3)}
\function{A3 = \A3 = 1 ? }
\function{A2 = simplify(x^\a2)}
\function{A1 = simplify(x^\a1)}
\function{A0 = simplify(x^\a0)}

\text{eqdiff = \N=2 ? \A2 f_{}''(x) + \A1 f'(x) + \A0 f(x) = 0 : 
\A3 f^{(3)}(x) + \A2 f''(x) + \A1 f'(x) + \A0 f(x) = 0 }

function{A2 = \N=2 ? simplify(x^\a2)}
text{eqdiff=\N=2? \A2*f''(x)}

\if{\N=2}{
  \text{reponse1 = n*(n-1)}
  \text{reponse2 = simplify(n-1+\a2-\a1)}
  \text{reponse3 = 1}
  \text{reponse4 = 0}
  \integer{reponse5 = \a1-\a2+1}
  \integer{reponse6 = \a0-\a2+2}
  \integer{reponse7 = 0}
  \integer{degre = \reponse6}
}

\if{\N=3}{
  \text{reponse1 = n*(n-1)*(n-2)}
  \text{reponse2 = simplify((n-1+\a3-\a2)*(n-2+\a3-\a2))}
  \text{reponse3 = simplify(n-2+\a3-\a1)}
  \text{reponse4 = 1}
  \integer{reponse5 = \a2-\a3+1}
  \integer{reponse6 = \a1-\a3+2}
  \integer{reponse7 = \a0-\a3+3}
  \integer{degre = \reponse7}
}


#if #TARGET(eqdiff1)
\text{STEPS=\N=2 ? r1,r2,r3,r4,r6,r7 : r1,r2,r3,r4,r5,r6,r7,r8}
\steps{\STEPS}
#else
\text{STEPS=\N=2 ? r2,r3,r4 : r1,r2,r3,r4}
\steps{\STEPS}
#endif

//nonc

#if #TARGET(eqdiff1)

\statement{

On se donne l'quation diffrentielle <br><p align=center>\(\eqdiff).<br></p>
On suppose que la solution est une srie entire de la forme 
\(\sum_n a_n x^n).  
Ses coefficients \(a_n) vrifient une relation de rcurrence. <br>
Quel est l'ordre de la rcurrence ? \embed{reply 1,2} 
<p>
Quelle est la relation de rcurrence pour n assez grand ? 
<p align= center >
\if{\N=2}{
\embed{reply 2,10} * \(a_n) + \embed{reply 3,10} * <i>a<sub>n-\embed{reply 6,1}</sub></i>
+ \embed{reply 4,10} * <i>a<sub>n-\embed{reply 7,1}</sub></i>=0
}
\if{\N=3}{
\embed{reply 2,10} * \(a_n) + \embed{reply 3,10} * <i>a<sub>n-\embed{reply 6,1}</sub></i>
+ \embed{reply 4,10} * <i>a<sub>n-\embed{reply 7,1}</sub></i>+ \embed{reply 5,10} * 
<i>a<sub>n-\embed{reply 8,1}</sub></i>=0
}
</p>
}

//fin de l'nonc

\answer{}{\degre}{type=integer}
\answer{}{\reponse1}{type=algexp}
\answer{}{\reponse2}{type=algexp}
\answer{}{\reponse3}{type=algexp}
\answer{}{\reponse4}{type=algexp}
\answer{}{\reponse5}{type=numeric}
\answer{}{\reponse6}{type=numeric}
\answer{}{\reponse7}{type=numeric}


#else

\text{cond = \N=3 ? 
  \(\reponse1 a_n + \reponse2 a_(n-\reponse5) + (\reponse3) a_(n-\reponse6) + a_(n-\reponse7) = 0) : 
  \(\reponse1 a_n + (\reponse2) a_(n-\reponse5) + a_(n-\reponse6) = 0) 
}




\statement{

Une srie entire de la forme \(\sum_n a_n x^n) vrifie la condition de rcurrence
<p align= center > 
\cond.
</p>
L'quation diffrentielle qu'elle vrifie est alors
<p align= center>
\if{\N=3}{
\(x_{})<i><sup>\embed{reply 1,1}</sup></i>\(f^{(3)}(x)) 
+ \(x_{})<i><sup>\embed{reply 2,1}</sup></i> \(f^{(2)}(x))
+ \(x_{})<i><sup>\embed{reply 3,1}</sup></i> \(f^{(1)}(x))
+ \(x_{})<i><sup>\embed{reply 4,1}</sup></i> \(f^{}(x)=0).
}
\if{\N=2}{
\(x_{})<i><sup>\embed{reply 2,1}</sup></i> \(f^{(2)}(x))
+ \(x_{})<i><sup>\embed{reply 3,1}</sup></i> \(f^{(1)}(x))
+ \(x_{})<i><sup>\embed{reply 1,1}</sup></i> \(f^{}(x)=0).
}

}


\answer{}{\a3}{type=numeric}
\answer{}{\a2}{type=numeric}
\answer{}{\a1}{type=numeric}
\answer{}{\a0}{type=numeric}






#endif
