target = accessible communique
   
\language{fr}
\author{Sophie Lemaire}
\email{sophie.lemaire@math.u-psud.fr}
\computeanswer{yes}

/*Creation d'une matrice stochastique ayant d etats */

\integer{d=randint(4..6)}
\integer{v=randint(2,\d/2+1)}

/*creation du 1er comme realisations de multinomiales */
/*avec comme parametre la loi uniforme*/

\real{k=1/\d}
\text{p=wims(values \k for x=1 to \d-1)}
\real{s=1-(\d-1)*\k} /*pour que la somme soit exactement 1*/
\text{p=\p,\s}

/*choix des etats*/
\integer{x=randint(1..\d)}
\integer{u=randint(1..\d-1)}
\if{\u<\x}{\integer{y=\u}}{\integer{y=\u+1}}
\matrix{A=slib(stat/multinomial \d,\v,[\p])}

#if #TARGET(accessible)
\title{Les tats accessibles} 
\matrix{P=pari(A=Mat([\A]);if(A[\x,\y]>0,
if((A[\x,\x]+A[\x,\y])<=\v,A[\x,\x]=A[\x,\x]+A[\x,\y];
A[\x,\y]=0));Q=matrix(\d,\d,i,j,A[i,j]/\v);print(Q))}
  
\matrix{rep=pari(P=Mat([\P]);Q=P;r=Q[\x,];s=r;for(k=1,\d-1,
r=r*P;s=r+s);print(s))}

#elif #TARGET(communique)

\title{Communication entre les tats} 
\matrix{P=pari(A=Mat([\A]);if(A[\x,\y]>0,
if((A[\x,\x]+A[\x,\y])<=\v,A[\x,\x]=A[\x,\x]+A[\x,\y];
A[\x,\y]=0));if(A[\y,\x]>0,
if((A[\y,\y]+A[\y,\x])<=\v,A[\y,\y]=A[\y,\y]+A[\y,\x];
A[\y,\x]=0));Q=matrix(\d,\d,i,j,A[i,j]/\v);print(Q))}

\matrix{rep=pari(P=Mat([\P]);Q=P;r=Q[\x,];s=Q[,\x];
for(k=1,\d-1,QQ=Q*P;r=r+QQ[\x,];s=s+QQ[,\x];Q=QQ);t=r;
for(k=1,\d,t[k]=t[k]*s[k]);print(t))}
#endif
\text{liste=1}
#if #TARGET(accessible)
\for{i=1 to \d}{
  \if{\rep[1;\i]>0}{\integer{etat=\i+1}\text{liste=\liste,\etat}}
}
#elif #TARGET(communique)
\for{i=1 to \x-1}{
  \if{\rep[1;\i]>0}{\integer{etat=\i+1}\text{liste=\liste,\etat}}
}
\integer{etat=\x+1}
\text{liste=\liste,\etat}
\for{i=\x+1 to \d}{
  \if{\rep[1;\i]>0}{\integer{etat=\i+1}\text{liste=\liste,\etat}}
}
#endif
\text{nacc=wims(itemcnt  \liste)}
\text{la=1}
\if{\nacc>1}{\text{liste=wims(listcomplement \la in \liste)}}
\text{choix1=aucun des tats}
\text{choixx=l'tat \x}
\text{choix=\choix1}
\for{i=1 to \d}{\text{choix=\choix, l'tat \i}}
\statement{On considre une chane de Markov homogne dont les tats sont
numrots de 1  \d et dont la  matrice de transition  est :
 <center>\([\P]) </center>
<p> 
#if #TARGET(accessible)
Cocher <b>tous</b> les  tats accessibles  partir de l'tat <font color=navy>\x</font> (s'il n'y en a pas, cocher "aucun des tats"). 
#elif #TARGET(communique)
Cocher <b>tous</b> les  tats qui communiquent avec l'tat <b><font color=navy>\x</font></b> (s'il n'y en a pas, cocher "aucun des tats"). 
#endif
</p> 
<center>\embed{reply1,20}</center>
}
\answer{ }{\liste;\choix}{type=checkbox}
#if #TARGET(communique)
\feedback{\reply1  issametext \choix1 or \choixx  notlineof \reply1}
{NB : <font color=green>par convention, un tat communique toujours avec lui-mme</font>}
#endif